/**
 * @license
 * Copyright 2017 Google Inc. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
import { Features } from './environment_util';
import { KernelBackend } from './kernels/backend';
import { MathBackendCPU } from './kernels/backend_cpu';
export declare function envSatisfiesConstraints(constraints: Features): boolean;
export declare function parseKarmaFlags(args: string[]): TestEnv;
export declare function describeWithFlags(name: string, constraints: Features, tests: (env: TestEnv) => void): void;
export interface TestEnv {
    name: string;
    factory: () => KernelBackend;
    features: Features;
}
export declare let TEST_ENVS: TestEnv[];
export declare const CPU_FACTORY: () => MathBackendCPU;
export declare function setTestEnvs(testEnvs: TestEnv[]): void;
