import * as tf from './index';

async function main() {
  console.log(tf.version);

  const model = tf.sequential();
  model.add(
      tf.layers.dense({units: 4000, inputShape: [20], activation: 'relu'}));
  model.add(tf.layers.dense({units: 2000, activation: 'relu'}));
  model.add(tf.layers.dense({units: 1000, activation: 'relu'}));
  model.add(tf.layers.dense({units: 1}));
  model.compile({loss: 'meanSquaredError', optimizer: 'sgd'});
  const numExamples = 10000;
  const xs = tf.randomUniform([numExamples, 20]);
  // const ys = tf.randomUniform([numExamples, 1]);
  const t0 = tf.util.now();
  model.predict(xs).dataSync();
  const t1 = tf.util.now();
  console.log(t1 - t0);

  // const model = tf.sequential();
  // model.add(tf.layers.lstm({units: 128, inputShape: [20, 20]}));
  // model.add(tf.layers.dense({units: 1}));
  // model.compile({loss: 'meanSquaredError', optimizer: 'sgd'});

  // const numExamples = 10000;
  // const xs = tf.randomUniform([numExamples, 20, 20]);
  // const ys = tf.randomUniform([numExamples, 1]);

  // await model.fit(xs, ys, {epochs: 1});

  // const model = await tf.loadModel(
  //     'https://storage.googleapis.com/tfjs-models/tfjs/mobilenet_v1_0.25_224/model.json');
  // const numExamples = 1000;
  // const xs = tf.randomUniform([numExamples, 224, 224, 3]);
  // const t0 = tf.util.now();
  // model.predict(xs);
  // const t1 = tf.util.now();
  // console.log(t1 - t0);
}

main();
