export declare type TimedMenuAction = string;
export declare type TimedMenuNodeSpec = {
    name: string;
    timeToLiveMillis?: number | null;
    action?: TimedMenuAction;
    timeOutAction?: TimedMenuAction;
    regressSteps?: number;
    children?: TimedMenuNodeSpec[];
};
export declare type StateChangeType = 'advance' | 'init' | 'leaf' | 'regress' | 'regressSteps' | 'reset';
export declare type TimedMenuSpec = {
    nodes: TimedMenuNodeSpec[];
    metadata?: {};
};
export declare type TimedMenuTickCallback = (stateSequence: string[], stateChangeType: StateChangeType, timeOutAction?: TimedMenuAction) => Promise<void>;
export interface TimedMenuRuntimeOptions {
    tickMillis?: number;
    timeToLiveMultiplier?: number;
}
export declare class TimedMenu {
    readonly config: TimedMenuSpec;
    readonly callback?: TimedMenuTickCallback;
    private stateSequence;
    private lastEventTimeMillis;
    private intervalTask;
    private tickMillis;
    private timeToLiveMultiplier;
    constructor(config: TimedMenuSpec, callback?: TimedMenuTickCallback, runtimeOptions?: TimedMenuRuntimeOptions);
    registerEvent(name: string): TimedMenuAction;
    protected tick(): void;
    stopTimer(): void;
}
