"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var timed_menu_1 = require("./timed_menu");
function sleep(millis) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2, new Promise(function (resolve) {
                    setTimeout(function () { return resolve(); }, millis);
                })];
        });
    });
}
describe('TimedMenu', function () {
    var ONE_LEVEL_MENU_SPEC = {
        nodes: [{ name: 'foo', action: 'fooAction' }, { name: 'bar', action: 'barAction' }]
    };
    var TWO_LEVEL_MENU_SPEC = {
        nodes: [
            {
                name: 'foo',
                action: 'fooAction',
                timeToLiveMillis: 100,
                children: [{ name: 'qux', action: 'quxAction' }]
            },
            {
                name: 'bar',
                action: 'barAction',
                timeToLiveMillis: 200,
                children: [{ name: 'bralt', action: 'braltAction' }]
            }
        ]
    };
    it('One-level menu: correct state and actions', function () { return __awaiter(_this, void 0, void 0, function () {
        var tickMillis, menu;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    tickMillis = 10;
                    menu = new timed_menu_1.TimedMenu(ONE_LEVEL_MENU_SPEC, null, { tickMillis: tickMillis });
                    expect(menu.registerEvent('foo')).toEqual('fooAction');
                    return [4, sleep(tickMillis)];
                case 1:
                    _a.sent();
                    expect(menu.registerEvent('bar')).toEqual('barAction');
                    return [4, sleep(tickMillis)];
                case 2:
                    _a.sent();
                    expect(menu.registerEvent('foo')).toEqual('fooAction');
                    return [4, sleep(tickMillis)];
                case 3:
                    _a.sent();
                    expect(menu.registerEvent('qux')).toEqual(null);
                    return [2];
            }
        });
    }); });
    it('Two-level menu: correct state and actions', function () { return __awaiter(_this, void 0, void 0, function () {
        var tickMillis, menu;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    tickMillis = 10;
                    menu = new timed_menu_1.TimedMenu(TWO_LEVEL_MENU_SPEC, null, { tickMillis: tickMillis });
                    expect(menu.registerEvent('foo')).toEqual('fooAction');
                    return [4, sleep(tickMillis)];
                case 1:
                    _a.sent();
                    expect(menu.registerEvent('qux')).toEqual('quxAction');
                    return [4, sleep(tickMillis)];
                case 2:
                    _a.sent();
                    expect(menu.registerEvent('bar')).toEqual('barAction');
                    return [4, sleep(tickMillis)];
                case 3:
                    _a.sent();
                    expect(menu.registerEvent('bralt')).toEqual('braltAction');
                    return [4, sleep(tickMillis)];
                case 4:
                    _a.sent();
                    expect(menu.registerEvent('foo')).toEqual('fooAction');
                    return [4, sleep(tickMillis)];
                case 5:
                    _a.sent();
                    expect(menu.registerEvent('qux')).toEqual('quxAction');
                    return [4, sleep(tickMillis)];
                case 6:
                    _a.sent();
                    expect(menu.registerEvent('bar')).toEqual('barAction');
                    return [4, sleep(tickMillis)];
                case 7:
                    _a.sent();
                    expect(menu.registerEvent('qux')).toEqual(null);
                    return [4, sleep(tickMillis)];
                case 8:
                    _a.sent();
                    expect(menu.registerEvent('bralt')).toEqual('braltAction');
                    return [4, sleep(tickMillis)];
                case 9:
                    _a.sent();
                    expect(menu.registerEvent('foo')).toEqual('fooAction');
                    return [4, sleep(tickMillis)];
                case 10:
                    _a.sent();
                    expect(menu.registerEvent('bralt')).toEqual(null);
                    return [4, sleep(tickMillis)];
                case 11:
                    _a.sent();
                    expect(menu.registerEvent('qux')).toEqual('quxAction');
                    return [2];
            }
        });
    }); });
    it('Two-level menu: timeout', function (done) {
        var tickMillis = 10;
        var menu = new timed_menu_1.TimedMenu(TWO_LEVEL_MENU_SPEC, null, { tickMillis: tickMillis });
        menu.registerEvent('foo');
        setTimeout(function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        expect(menu.registerEvent('qux')).toEqual(null);
                        return [4, sleep(tickMillis)];
                    case 1:
                        _a.sent();
                        expect(menu.registerEvent('bar')).toEqual('barAction');
                        return [4, sleep(tickMillis)];
                    case 2:
                        _a.sent();
                        expect(menu.registerEvent('bralt')).toEqual('braltAction');
                        done();
                        return [2];
                }
            });
        }); }, 150);
    });
    it('Two-level menu: callback is invoked', function () { return __awaiter(_this, void 0, void 0, function () {
        var callbackInvokeRecords, callback, tickMillis, menu;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    callbackInvokeRecords = [];
                    callback = function (stateSequence) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            callbackInvokeRecords.push(stateSequence);
                            return [2];
                        });
                    }); };
                    tickMillis = 10;
                    menu = new timed_menu_1.TimedMenu(TWO_LEVEL_MENU_SPEC, callback, { tickMillis: tickMillis });
                    menu.registerEvent('foo');
                    return [4, sleep(tickMillis)];
                case 1:
                    _a.sent();
                    expect(callbackInvokeRecords.length).toBeGreaterThan(0);
                    expect(callbackInvokeRecords[callbackInvokeRecords.length - 1])
                        .toEqual(['foo']);
                    return [2];
            }
        });
    }); });
    it('Two-level menu: callback is invoked: before any events', function () { return __awaiter(_this, void 0, void 0, function () {
        var e_1, _a, callbackInvokeRecords, callback, tickMillis, menu, callbackInvokeRecords_1, callbackInvokeRecords_1_1, record;
        var _this = this;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    callbackInvokeRecords = [];
                    callback = function (stateSequence) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            callbackInvokeRecords.push(stateSequence);
                            return [2];
                        });
                    }); };
                    tickMillis = 10;
                    menu = new timed_menu_1.TimedMenu(TWO_LEVEL_MENU_SPEC, callback, { tickMillis: tickMillis });
                    expect(menu == null).toEqual(false);
                    return [4, sleep(tickMillis)];
                case 1:
                    _b.sent();
                    expect(callbackInvokeRecords.length).toBeGreaterThan(0);
                    try {
                        for (callbackInvokeRecords_1 = __values(callbackInvokeRecords), callbackInvokeRecords_1_1 = callbackInvokeRecords_1.next(); !callbackInvokeRecords_1_1.done; callbackInvokeRecords_1_1 = callbackInvokeRecords_1.next()) {
                            record = callbackInvokeRecords_1_1.value;
                            expect(record).toEqual([]);
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (callbackInvokeRecords_1_1 && !callbackInvokeRecords_1_1.done && (_a = callbackInvokeRecords_1.return)) _a.call(callbackInvokeRecords_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                    return [2];
            }
        });
    }); });
});
//# sourceMappingURL=timed_menu_test.js.map